#!/bin/bash

# Umount all thing still mounted in this vm

# parameters :
# ./script start vmname vmdir server login pass uid persistentdir

action="$1"
vmname="$2"
vmdir="$3"
server="$4"
login="$5"
pass="$6"
uid="$7"
pdir="$8"

# Nothing to do if not a start
if [ "$action" != "stop" ] ; then
  exit 0
fi

function umount_sub() {
  # Umount all subdir of the directory in the parameters
  # We begin with deeper one
  vmdir="$1"

  # No ending /
  if [ "${vmdir:${#vmdir}-1:1}" == "/" ] ; then
    vmdir="${vmdir:0:${#vmdir}-1}"
  fi

  vd="$vmdir/rootfs"
  cat /proc/mounts |while read aa ; do
    m="$(echo $aa|cut -d ' ' -f 2)"

    # If $m begin like $vd (but is a subfolder)
    if [ "${m:0:${#vd}}" == "$vd" -a ${#m} -gt ${#vd} ] ; then
      echo "$(echo -n $m|wc -m) $m"
    fi 
  done | sort -rn | while read bb cc ; do
    umount "$cc"
    sleep .1
  done
}

umount_sub "$vmdir"
